package com.qr.flutter_toolkit.utils;

import android.content.Context;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;

import androidx.annotation.NonNull;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import io.flutter.Log;

public class PermissionUtils {
    private static final String TAG = PermissionUtils.class.getSimpleName();

    public static List<String> getManifestPermissions(@NonNull Context context) {
        try {
            PackageInfo packageInfo = context.getPackageManager().getPackageInfo(context.getPackageName(), PackageManager.GET_PERMISSIONS);
            if (packageInfo == null) {
                Log.d(TAG, "Unable to get Package info, will not be able to determine permissions to request.");
                return new ArrayList<>();
            }
            return new ArrayList<>(Arrays.asList(packageInfo.requestedPermissions));
        } catch (PackageManager.NameNotFoundException e) {
            Log.d(TAG, "Unable to check manifest for permission: ", e);
            return new ArrayList<>();
        }
    }
}
