import 'dart:typed_data';

import 'package:flutter/material.dart';
import 'package:flutter_toolkit/video_thumbnail.dart';

void main() => runApp(MaterialApp(home: MyApp()));

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  int status = 0;
  Uint8List uint8list;
  String error;

  @override
  void initState() {
    super.initState();
    VideoThumbnail.thumbnailData(
            video:
                "http://10.30.140.221:8083/tramFile/20191025/090311bff748bd-637f-427b-8e0d-279370a00aab5072025926593676168.mp4",imageFormat:ImageFormat.PNG)
        .then((value) {
      status = 1;
      uint8list = value;
      if (mounted) {
        setState(() {});
      }
    }, onError: (e) {
      status = 2;
      error = e.toString();
      if (mounted) {
        setState(() {});
      }
    });
  }

  @override
  void dispose() {
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: Builder(
        builder: (context) {
          if (status == 0) {
            return Center(
              child: CircularProgressIndicator(),
            );
          } else if (status == 1) {
            return Center(
              child: Image.memory(uint8list),
            );
          } else if (status == 2) {
            return Container(
              child: Center(
                child: Text("error: $error"),
              ),
            );
          }
          throw "No Impl Status: $status";
        },
      ),
    );
  }
}
