import 'package:flutter/services.dart';

class PackageInfo {
  final int versionCode;
  final String versionName;
  final String packageName;

  PackageInfo({
    this.versionCode,
    this.versionName,
    this.packageName,
  });

  static const MethodChannel _methodChannel =
      const MethodChannel("com.qr.flutter_toolkit/package_info/methods");

  static Future<PackageInfo> get getPackageInfo async {
    Map<String, dynamic> map =
        await _methodChannel.invokeMapMethod("getPackageInfo");
    return PackageInfo(
      packageName: map["packageName"],
      versionCode: map["versionCode"],
      versionName: map["versionName"],
    );
  }

  static Future<String> get getVersionName async {
    return await _methodChannel.invokeMethod("getVersionName");
  }

  static Future<int> get getVersionCode async {
    return await _methodChannel.invokeMethod("getVersionCode");
  }

  static Future<String> get getPackageName async {
    return await _methodChannel.invokeMethod("getPackageName");
  }
}
